﻿using System;
using System.Linq;

using Styx;
using Styx.Common;
using Styx.Helpers;
using Styx.Plugins;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.TreeSharp;

namespace WoW_Guild_Banners
{
    public class WowBannersPlugin : HBPlugin
    {
        public override string Name {get { return "WowBannerPlugin"; }}
        public override string Author { get { return "ESCA"; }}
        public override Version Version { get { return new Version(1, 7); }}

		public static LocalPlayer Me = StyxWoW.Me;

        //alliance
        public static WoWItem AllianceBannerofCooperation = Me.BagItems.FirstOrDefault(item => item.Entry == 63359);
        public static WoWItem AllianceStandardofUnity = Me.BagItems.FirstOrDefault(item => item.Entry == 64398);
        public static WoWItem AllianceBattleStandardofCoordination = Me.BagItems.FirstOrDefault(item => item.Entry == 64399);

        //horde 
        public static WoWItem HordeBannerofCooperation = Me.BagItems.FirstOrDefault(item => item.Entry == 64400);
        public static WoWItem HordeStandardofUnity = Me.BagItems.FirstOrDefault(item => item.Entry == 64401);
        public static WoWItem HordeBattleStandardofCoordination = Me.BagItems.FirstOrDefault(item => item.Entry == 64402);

        public static bool IsViable(WoWObject wowObject)
        {
            return (wowObject != null) && wowObject.IsValid;
        }

        public bool BannerBuff()
        {
            return IsViable(Me) && !Me.Mounted && !Me.IsOnTransport && !Me.IsResting && !Me.IsDead && Me.Combat;
        }

        private static bool CanUseItem(WoWItem item)
        {
            if (item == null)
                return false;
            /*string myitemRank = item.ItemInfo.RequiredReputationRank.ToString();
            Logging.Write(myitemRank);
            string myitemfractionid = item.ItemInfo.RequiredReputationFactionId.ToString();
            Logging.Write(myitemfractionid); */
            object wtf = item.ItemInfo.RequiredReputationFactionId;
            int wtf1 = (int)wtf;
            uint wtf2 = (uint)wtf1;
            /*if (Me.GetReputationLevelWith(wtf2) == Styx.WoWUnitReaction.Friendly)
            {
                Logging.Write("Friendly Rep! Can use it!");
            }*/
            if (Me.GetReputationLevelWith(wtf2) == Styx.WoWUnitReaction.Neutral)
            {
                Logging.Write("Neutral Rep is to low!");
                return false;
            }
            return item.Usable && item.Cooldown <= 0 
                && ((Me.GetReputationLevelWith(wtf2) == Styx.WoWUnitReaction.Friendly)
                || (Me.GetReputationLevelWith(wtf2) == Styx.WoWUnitReaction.Honored)
                || (Me.GetReputationLevelWith(wtf2) == Styx.WoWUnitReaction.Revered)
                || (Me.GetReputationLevelWith(wtf2) == Styx.WoWUnitReaction.Exalted));
        }

        public override void Pulse()
        {
            if (!BannerBuff())
                return;
            if (CanUseItem(AllianceBannerofCooperation))
            {
                AllianceBannerofCooperation.Use();
                Logging.Write("Alliance Banner of Cooperation piled! Enjoy free xp!");
                return;
            }
            if (CanUseItem(AllianceStandardofUnity))
            {
                AllianceStandardofUnity.Use();
                Logging.Write("Alliance Standard of Unity piled! Enjoy free xp!");
                return;
            }
            if (CanUseItem(AllianceBattleStandardofCoordination))
            {
                AllianceBattleStandardofCoordination.Use();
                Logging.Write("Alliance Battle Standard of Coordination piled! Enjoy free xp!");
                return;
            }
            if (CanUseItem(HordeBannerofCooperation))
            {
                HordeBannerofCooperation.Use();
                Logging.Write("Horde Banner of Cooperation piled! Enjoy free xp!");
                return;
            }
            if (CanUseItem(HordeStandardofUnity))
            {
                HordeStandardofUnity.Use();
                Logging.Write("Horde Standard of Unity piled! Enjoy free xp!");
                return;
            }
            if (CanUseItem(HordeBattleStandardofCoordination))
            {
                HordeBattleStandardofCoordination.Use();
                Logging.Write("Horde Battle Standard of Coordination piled! Enjoy free xp!");
                return;
            }

        }
    }
}
